/**
 * HXITCE2.java
 *
 * File generated from the medication2::HXITCE2 uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication2;

import java.util.List;

// End of user code
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class HXITCE2.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "HXIT_CE", propOrder = {
	"validTime"
})
@XmlRootElement(name = "HXIT_CE")
public class HXITCE2 extends net.ihe.gazelle.medication2.CE2 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                          The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                      .
	 */
	@XmlElement(name = "validTime", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication2.IVLTS2 validTime;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return validTime.
	 * @return validTime :                          The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                      
	 */
	public net.ihe.gazelle.medication2.IVLTS2 getValidTime() {
	    return validTime;
	}
	
	/**
	 * Set a value to attribute validTime.
	 * @param validTime :                          The time interval during
	                                which the given information                         was, is, or is
	                                expected to be valid. The interval can                         be
	                                open or closed, as well as infinite or undefined on
	                                either side.                      .
	 */
	public void setValidTime(net.ihe.gazelle.medication2.IVLTS2 validTime) {
	    this.validTime = validTime;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication2");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "HXIT_CE").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(HXITCE2 hXITCE2, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (hXITCE2 != null){
   			net.ihe.gazelle.medication2.CE2.validateByModule(hXITCE2, _location, cvm, diagnostic);
			net.ihe.gazelle.medication2.IVLTS2.validateByModule(hXITCE2.getValidTime(), _location + "/validTime", cvm, diagnostic);
    	}
    }

}
